export default class API {
    clientID: string;
    oauthToken: string;
    proxy: string;
    static headers: {
        "user-agent": string;
    };
    constructor(clientID: string, oauthToken: string, proxy: string);
    /**
     * Gets an endpoint from the Soundcloud API.
     */
    get: (endpoint: string, params?: any) => Promise<any>;
    /**
     * Gets an endpoint from the Soundcloud V2 API.
     */
    getV2: (endpoint: string, params?: any) => Promise<any>;
    /**
     * Some endpoints use the main website as the URL.
     */
    getWebsite: (endpoint: string, params?: any) => Promise<any>;
    /**
     * Gets a URL, such as download, stream, attachment, etc.
     */
    getURL: (URI: string, params?: any) => Promise<any>;
    post: (endpoint: string, params?: any) => Promise<any>;
    getClientID: (reset?: boolean) => Promise<string>;
}
