"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
var chai_1 = require("chai");
require("mocha");
var login_1 = require("./login");
describe("Tracks", function () {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            it("should get a track", function () {
                return __awaiter(this, void 0, void 0, function () {
                    var response;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, login_1.soundcloud.tracks.get("https://soundcloud.com/tenpimusic/snowflake")];
                            case 1:
                                response = _a.sent();
                                chai_1.assert(response.hasOwnProperty("description"));
                                return [2 /*return*/];
                        }
                    });
                });
            });
            it("should search tracks", function () {
                return __awaiter(this, void 0, void 0, function () {
                    var response;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, login_1.soundcloud.tracks.search({ q: "virtual riot" })];
                            case 1:
                                response = _a.sent();
                                chai_1.assert(response[0].hasOwnProperty("description"));
                                return [2 /*return*/];
                        }
                    });
                });
            });
            it("should get track comments", function () {
                return __awaiter(this, void 0, void 0, function () {
                    var response;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, login_1.soundcloud.tracks.comments("https://soundcloud.com/tenpimusic/snowflake")];
                            case 1:
                                response = _a.sent();
                                chai_1.assert(response[0].hasOwnProperty("body"));
                                return [2 /*return*/];
                        }
                    });
                });
            });
            it("should get a comment", function () {
                return __awaiter(this, void 0, void 0, function () {
                    var response;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, login_1.soundcloud.tracks.comment("https://soundcloud.com/tenpimusic/snowflake", 577938945)];
                            case 1:
                                response = _a.sent();
                                chai_1.assert(response.hasOwnProperty("body"));
                                return [2 /*return*/];
                        }
                    });
                });
            });
            it("should get favoriters", function () {
                return __awaiter(this, void 0, void 0, function () {
                    var response;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, login_1.soundcloud.tracks.favoriters("https://soundcloud.com/tenpimusic/kudasai")];
                            case 1:
                                response = _a.sent();
                                chai_1.assert(response[0].hasOwnProperty("description"));
                                return [2 /*return*/];
                        }
                    });
                });
            });
            /* 401 Error - Possibly bug with soundcloud.
            it("should get a favoriter", async function() {
                const response = await soundcloud.tracks.favoriter("https://soundcloud.com/inf1n1temusic/inf1n1tea-konus-nova1", "tenpimusic")
                assert(response.hasOwnProperty("description"))
            })*/
            it("should get a secret token", function () {
                return __awaiter(this, void 0, void 0, function () {
                    var response;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, login_1.soundcloud.tracks.secretToken("https://soundcloud.com/tenpimusic/kudasai")];
                            case 1:
                                response = _a.sent();
                                chai_1.assert(response.hasOwnProperty("token"));
                                return [2 /*return*/];
                        }
                    });
                });
            });
            return [2 /*return*/];
        });
    });
});
